#!/usr/bin/perl

# cntmake.pl - sets the group and permissions on all .cnt files in a user's
# home directory so that they can be used by the Server-side Include (SSI)
# counter software.
#
# Written by William D. Herrin, herrin@dirtside.com
# Released to the public domain in 2003.

for ($i=$#INC; $i>=0; $i--) {
  $INC[$i+1] = $INC[$i];
}
$INC[0] = "/usr/lib/apache";
require "stat.ph";

$login = $ARGV[0];

chdir ("/");
$pwline = `grep ^$login: /etc/passwd`;
chop $pwline;
($login,$junk,$uid,$gid,$gecos,$home,$shell) = split ':', $pwline;

$dir = "$home/www/";

if ($uid < 500) {
  print "<P><font color=\"#ff0000\">Cannot authorize counter files in " .
	"$dir because $login is a system user.</P>";
  exit (0);
}
if (!($dir =~ /^\/home\/.\/$login\/www\//)) {
  print "<P><font color=\"#ff0000\">Cannot authorize counter files in " .
  print "$dir because its not in the format /home/u/user/www/.</P>";
  exit (0);
}
($fuid,$mode) = (stat $dir)[4,2];
if (($uid != $fuid) || ( ! S_ISDIR($mode)) ) {
  print "<P><font color=\"#ff0000\">Cannot authorize counter files in " .
	"$dir because its not a directory or not owned by the user.</P>";
  exit (0);
}

print "<h3>Authorizing counter files in $dir:</h3>\n\n<P>";

$files = `/usr/bin/find $dir -name \\*.cnt -print`;
@f = split /\n/,$files;
$dirlen = length ($dir);
$authcount = 0;
$totalcount = 0;
foreach $file (@f) {
  $totalcount ++;
  $fdir = substr ($file,0,$dirlen);
  if ($fdir ne $dir) {
    print "$file <FONT COLOR=\"#ff0000\">NOT AUTHORIZED</FONT>.<BR />\n";
    next;
  }
  if ($file =~ /\.\//) {
    print "$file <FONT COLOR=\"#ff0000\">NOT AUTHORIZED</FONT>.<BR />\n";
    next;
  }
  ($fuid,$mode) = (stat $file)[4,2];
  if (($uid != $fuid) || ( ! S_ISREG($mode)) ) {
    print "$file <FONT COLOR=\"#ff0000\">NOT AUTHORIZED</FONT>.<BR />\n";
    next;
  }
  if ($file =~ /_vti_/) {
    print "$file <FONT COLOR=\"#ff0000\">NOT AUTHORIZED</FONT>.<BR />\n";
    next;
  }
  print "$file <FONT COLOR=\"#00bf00\">AUTHORIZED</FONT>.<BR />\n";
  print "<code>&nbsp;&nbsp;chmod 660 $file</code><BR />\n";
  system ("chmod 660 $file 2>&1");
  print "<code>&nbsp;&nbsp;chgrp www-data $file</code><BR />\n";
  system ("chgrp www-data $file 2>&1");
  $authcount ++;
  next;
}
print "</P>\n";

print "<P>$authcount/$totalcount <CODE>.cnt</CODE> files converted.</P>";

exit (0);

